import 'dart:async';
import 'package:amap_flutter_base/amap_flutter_base.dart';
import 'package:clx_map_poi_search/core/clx_map_poi_search_platform_interface.dart';
import 'package:clx_map_poi_search/core/poi_result.dart';

class ClxMapPoiSearch {

  /// 单例
  static ClxMapPoiSearch instance = ClxMapPoiSearch._();
  ClxMapPoiSearch._() {
    setupSearch();
  }
  setupSearch() { }

  /// init
  initPoiSearch(AMapApiKey apiKey) {
    ClxMapPoiSearchPlatform.instance.initPoiSearch(apiKey);
  }

  /// 关键字搜索
  Future<PoiResult?> keywordsSearch(String keyWord) {
    return ClxMapPoiSearchPlatform.instance.keywordsSearch(keyWord);
  }

  /// 根据经纬度搜索
  Future<PoiResult?> aroundSearch(double latitude, double longitude) {
    return ClxMapPoiSearchPlatform.instance.aroundSearch(latitude, longitude);
  }

  /// 周边搜索
  Future<PoiResult?> aroundSearchAll(String keywords, { double? latitude, double? longitude, String? city }) {
    return ClxMapPoiSearchPlatform.instance.aroundSearchAll(keywords, latitude: latitude, longitude: longitude, city: city);
  }

  /// 两点间的直线距离计算
  Future<double?> getDistanceBetweenMapPoints(List<double?> pointF, List<double?> pointT,) {
    return ClxMapPoiSearchPlatform.instance.getDistanceBetweenMapPoints(pointF, pointT);
  }

}
